# Enriching 3rd Party Data

groundcover supports setting key attributes in ingested data by using special HTTP / gRPC headers, or by using specific key-value attributes. This is especially relevant when using 3rd party integrations where the groundcover sensors is not present.

{% hint style="success" %}
See each integration page for specific examples
{% endhint %}

## List of Attributes

<table data-full-width="false"><thead><tr><th width="112.08203125">Attribute</th><th width="250">From Resource Attribute</th><th width="250">From Request Header</th><th>Description</th></tr></thead><tbody><tr><td><code>workload</code></td><td><code>service.name</code></td><td><code>x-groundcover-service-name</code></td><td>The name of the service or workload</td></tr><tr><td><code>env_type</code></td><td><code>gc_env_type</code></td><td><code>x-groundcover-env-type</code></td><td>The type of environment (e.g. k8s, VM)</td></tr><tr><td><code>env</code></td><td><code>env_name</code></td><td><code>x-groundcover-env-name</code></td><td>The environment (e.g prod, dev)</td></tr><tr><td><code>source</code></td><td><code>source</code></td><td><code>x-groundcover-source</code></td><td>Source of the data</td></tr><tr><td><code>cluster</code></td><td><code>cluster</code></td><td><code>x-groundcover-cluster</code></td><td>Associated cluster name</td></tr></tbody></table>

## Priority and Precedence

When both resource attributes and headers are present:

* **Headers take precedence** over resource attributes
* If a header is not provided, the corresponding resource attribute will be used
* If neither is provided - we'd try to deduce from other attributes if possible


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.groundcover.com/integrations/data-sources/enriching-3rd-party-data.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
